interface IBinarySearchCheck {
    (mid: number): -1 | 0 | 1 | number;
}
interface IBinarySearchCheckBigint {
    (mid: bigint): -1 | 0 | 1 | number;
}
/**
 * Find the index of first element which greater or equals than the target element.
 *
 * @param lft   (close) non-negative integer in the range of [-2^31, 2^31)
 * @param rht   (open) non-negative integer in the range of [-2^31, 2^31)
 * @param check
 * @returns
 */
declare function lowerBound(lft: number, rht: number, check: IBinarySearchCheck): number | -1;
/**
 * Find the index of first element which greater or equal than the target element. (bigint version)
 *
 * @param lft   (close) bigint
 * @param rht   (open) bigint
 * @param check
 * @returns
 */
declare function lowerBoundBigint(lft: bigint, rht: bigint, check: IBinarySearchCheckBigint): bigint;

export { IBinarySearchCheck, IBinarySearchCheckBigint, lowerBound as default, lowerBound, lowerBoundBigint };
